#!/usr/bin/env python2
# -*- coding: utf-8 -*-

import ctypes as ct
import threading

def wrap_function(lib, funcname, restype, argtypes):
    """Simplify wrapping ctypes functions"""
    func = lib.__getattr__(funcname)
    func.restype = restype
    func.argtypes = argtypes
    return func

class analysis(object):
    m_lib_dir = ""

    def spawn(self, function, arg):
        thread = threading.Thread(target=getattr(self, function), args=(arg,))
        thread.start()
        return thread

    def enable_thread_safety(self):
        lib_test = ct.CDLL(self.m_lib_dir + '/libtest.so')
        wg_enable_thread_safety = wrap_function(lib_test, 'enable_thread_safety', None, None)
        wg_enable_thread_safety()

    def create_files(self):
        lib_test = ct.CDLL(self.m_lib_dir + '/libtest.so')
        create_files_ctypes = wrap_function(lib_test, 'create_files', None, None)
        create_files_ctypes()

    def analyze_file(self, file_name):
        lib_test = ct.CDLL(self.m_lib_dir + '/libtest.so')
        analyze_file_ctypes = wrap_function(lib_test, 'analyze_file', None, [ct.c_char_p])
        analyze_file_ctypes(file_name)

def test ():
    analysis.m_lib_dir = "/home/neo/Desktop"
    process = analysis()
    process.create_files()
    threads = []
    threads.append(process.spawn("analyze_file", "histo1.root"))
    threads.append(process.spawn("analyze_file", "histo2.root"))
    for thread in threads:
        thread.join()

if __name__ == '__main__':
    test()
